diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/CompareFunc.java b/game/client/src/main/java/net/minecraft/client/render/renderer/CompareFunc.java
new file mode 100644
index 000000000..2f8db596c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/CompareFunc.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.render.renderer;
+
+import org.lwjgl.opengl.GL41;
+
+public enum CompareFunc {
+    NEVER(GL41.GL_NEVER),
+    LESS(GL41.GL_LESS),
+    EQUAL(GL41.GL_EQUAL),
+    LESS_EQUAL(GL41.GL_LEQUAL),
+    GREATER(GL41.GL_GREATER),
+    NOT_EQUAL(GL41.GL_NOTEQUAL),
+    GREATER_EQUAL(GL41.GL_GEQUAL),
+    ALWAYS(GL41.GL_ALWAYS);
+    public final int cap;
+
+    CompareFunc(int cap) {
+        this.cap = cap;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/CullFace.java b/game/client/src/main/java/net/minecraft/client/render/renderer/CullFace.java
new file mode 100644
index 000000000..ab95e5c4c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/CullFace.java
@@ -0,0 +1,15 @@
+package net.minecraft.client.render.renderer;
+
+import org.lwjgl.opengl.GL41;
+
+public enum CullFace {
+    FRONT(GL41.GL_FRONT),
+    BACK(GL41.GL_BACK),
+    FRONT_AND_BACK(GL41.GL_FRONT_AND_BACK);
+
+    public final int cap;
+
+    CullFace(int cap) {
+        this.cap = cap;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/DrawMode.java b/game/client/src/main/java/net/minecraft/client/render/renderer/DrawMode.java
new file mode 100644
index 000000000..2e4312c7d
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/DrawMode.java
@@ -0,0 +1,27 @@
+package net.minecraft.client.render.renderer;
+
+import org.lwjgl.opengl.GL41;
+
+public enum DrawMode {
+    POINTS(GL41.GL_POINTS),
+    LINE_STRIP(GL41.GL_LINE_STRIP),
+    LINE_LOOP(GL41.GL_LINE_LOOP),
+    LINES(GL41.GL_LINES),
+    LINE_STRIP_ADJACENCY(GL41.GL_LINE_STRIP_ADJACENCY),
+    LINES_ADJACENCY(GL41.GL_LINES_ADJACENCY),
+    TRIANGLE_STRIP(GL41.GL_TRIANGLE_STRIP),
+    TRIANGLE_FAN(GL41.GL_TRIANGLE_FAN),
+    TRIANGLES(GL41.GL_TRIANGLES),
+    TRIANGLE_STRIP_ADJACENCY(GL41.GL_TRIANGLE_STRIP_ADJACENCY),
+    TRIANGLES_ADJACENCY(GL41.GL_TRIANGLES_ADJACENCY),
+    PATCHES(GL41.GL_PATCHES),
+    @Deprecated QUAD_STRIP(GL41.GL_QUAD_STRIP),
+    @Deprecated QUADS(GL41.GL_QUADS),
+    @Deprecated POLYGON(GL41.GL_POLYGON)
+    ;
+
+    public final int cap;
+    DrawMode(int cap) {
+        this.cap = cap;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/FrontFace.java b/game/client/src/main/java/net/minecraft/client/render/renderer/FrontFace.java
new file mode 100644
index 000000000..16c6c2c28
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/FrontFace.java
@@ -0,0 +1,13 @@
+package net.minecraft.client.render.renderer;
+
+import org.lwjgl.opengl.GL41;
+
+public enum FrontFace {
+    CW(GL41.GL_CW),
+    CCW(GL41.GL_CCW)
+    ;
+    public final int cap;
+    FrontFace(int cap) {
+        this.cap = cap;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
new file mode 100644
index 000000000..cec7baa36
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -0,0 +1,507 @@
+package net.minecraft.client.render.renderer;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.FogManager;
+import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.shader.Shader;
+import net.minecraft.client.render.tessellator.RenderBuffer;
+import net.minecraft.client.render.tessellator.TessellatorShader;
+import net.minecraft.core.util.helper.Color;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Matrix4f;
+import org.joml.Matrix4fStack;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
+import org.joml.Vector4dc;
+import org.joml.Vector4f;
+import org.joml.Vector4fc;
+import org.lwjgl.BufferUtils;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.nio.FloatBuffer;
+
+public class GLRenderer {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public static boolean DEBUG = false;
+    public static final int RENDER_FRAMES_STACK_SIZE = 64; // GL guaranteed stack size was 32, so 64 should be more than plenty :)
+
+    private static final @NotNull GLRenderer instance = new GLRenderer();
+
+    // Global configuration
+    private static boolean LIGHT_ENABLED = false;
+    private static final @NotNull Vector4f LIGHT_MODEL_AMBIENT = new Vector4f(0.2f, 0.2f, 0.2f, 1.0f);
+    private static final @NotNull Lighting.LightSource LIGHT_0 = new Lighting.LightSource();
+    private static final @NotNull Lighting.LightSource LIGHT_1 = new Lighting.LightSource();
+    static {
+        LIGHT_0.diffuse.set(1, 1, 1, 1);
+        LIGHT_0.specular.set(1, 1, 1, 1);
+    }
+    private static final @NotNull Matrix4f NORMAL_TRANSFORM_MATRIX = new Matrix4f().identity();
+
+    public static void globalSetLightEnabled(boolean flag) {
+        LIGHT_ENABLED = flag;
+    }
+
+    public static @NotNull Vector4f globalGetLightModelAmbient() {
+        return LIGHT_MODEL_AMBIENT;
+    }
+
+    public static @NotNull Lighting.LightSource globalGetLight0() {
+        return LIGHT_0;
+    }
+
+    public static @NotNull Lighting.LightSource globalGetLight1() {
+        return LIGHT_1;
+    }
+
+    public static @NotNull Matrix4f globalGetNormalTransformMatrix() {
+        return NORMAL_TRANSFORM_MATRIX;
+    }
+
+    // Debug Stack Config
+    private static final StackWalker STACK_WALKER = StackWalker.getInstance(StackWalker.Option.RETAIN_CLASS_REFERENCE);
+    private final StackTraceElement[] pushListenStack = new StackTraceElement[RENDER_FRAMES_STACK_SIZE];
+    private final StackTraceElement[] popListenStack = new StackTraceElement[RENDER_FRAMES_STACK_SIZE];
+
+    // Stacked configuration
+    private final @NotNull Matrix4fStack projectionMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
+    private final @NotNull Matrix4fStack viewMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
+    private final @NotNull Matrix4fStack modelMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
+
+    private final long[] stateConfigStack = new long[RENDER_FRAMES_STACK_SIZE];
+    private long currentStateConfig = State.DITHER.bitMask | State.MULTISAMPLE.bitMask; // Spec says these two are default on https://docs.gl/gl4/glEnable
+
+    private final int[] colorStack = new int[RENDER_FRAMES_STACK_SIZE];
+    private int currentColor = Color.intToIntARGB(255, 255, 255, 255);
+
+    private final Shader[] shaderStack = new Shader[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull Shader currentShader = Shaders.INTERFACE;
+
+    private final FogManager.FogState[] fogStateStack = new FogManager.FogState[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull FogManager.FogState currentFogState = new FogManager.FogState().disable();
+
+    private final CompareFunc[] depthFuncStack = new CompareFunc[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull CompareFunc currentDepthFunc = CompareFunc.LESS;
+
+    private final CullFace[] cullFaceStack = new CullFace[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull CullFace currentCullFace = CullFace.BACK;
+
+    private final BlendFactor[] sFactorStack = new BlendFactor[RENDER_FRAMES_STACK_SIZE];
+    private final BlendFactor[] dFactorStack = new BlendFactor[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull BlendFactor currentSFactor = BlendFactor.ONE;
+    private @NotNull BlendFactor currentDFactor = BlendFactor.ZERO;
+
+    private final FrontFace[] frontFaceStack = new FrontFace[RENDER_FRAMES_STACK_SIZE];
+    private @NotNull FrontFace currentFrontFace = FrontFace.CCW;
+
+    private final byte[] colorMaskStack = new byte[RENDER_FRAMES_STACK_SIZE];
+    private byte currentColorMask = 0b1111; // RGBA
+
+    private final boolean[] depthMaskStack = new boolean[RENDER_FRAMES_STACK_SIZE];
+    private boolean currentDepthMask = true;
+
+    private final float[] lineWidthStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private float currentLineWidth = 1f;
+
+    private final float[] polygonFactorStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private final float[] polygonUnitsStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private float currentPolygonFactor = 0f;
+    private float currentPolygonUnits = 0f;
+
+    private final float[] lightmapBlockStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private final float[] lightmapSkyStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private float currentLightmapBlock = 15.5f/16f;
+    private float currentLightmapSky = 15.5f/16f;
+
+    private int stackIndex = 0;
+
+
+    private final @NotNull Minecraft mc = Minecraft.getMinecraft();
+    private final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
+    private final @NotNull TessellatorShader tessellatorShader = new TessellatorShader("GLRender Tessellator", 0x200000);
+
+    public GLRenderer() {
+    }
+
+    public static void init() {
+    }
+
+    private static final FloatBuffer lightBuf = BufferUtils.createFloatBuffer(8);
+    private static final Matrix4f matBuf = new Matrix4f();
+    public static void globalSetUniforms(@NotNull Shader shader) {
+        shader.bind();
+        GL41.glUniformMatrix4fv(shader.getUniform("projection"), false, projectionM4f().get(instance.mat4fBuf));
+        GL41.glUniformMatrix4fv(shader.getUniform("projectionInv"), false, projectionM4f().invert(matBuf).get(instance.mat4fBuf));
+        GL41.glUniformMatrix4fv(shader.getUniform("view"), false, viewM4f().get(instance.mat4fBuf));
+        GL41.glUniformMatrix4fv(shader.getUniform("viewInv"), false, viewM4f().invert(matBuf).get(instance.mat4fBuf));
+        GL41.glUniformMatrix4fv(shader.getUniform("model"), false, modelM4f().get(instance.mat4fBuf));
+
+        GL41.glUniform4f(shader.getUniform("ucolor"), Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
+        GL41.glUniform1i(shader.getUniform("uticks"), instance.mc.ticksRan);
+        GL41.glUniform1f(shader.getUniform("upartialTick"), instance.mc.timer.partialTicks);
+
+        GL41.glUniform1f(shader.getUniform("uLineWidth"), instance.currentLineWidth);
+
+        double renderScale = (float) instance.mc.gameSettings.renderScale.value.scale;
+        int scaledWidth = (int) (renderScale * instance.mc.gameWindow.getWidthPixels());
+        int scaledHeight = (int) (renderScale * instance.mc.gameWindow.getHeightPixels());
+
+        GL41.glUniform1f(shader.getUniform("viewWidth"), scaledWidth);
+        GL41.glUniform1f(shader.getUniform("viewHeight"), scaledHeight);
+
+        GL41.glUniform1i(shader.getUniform("texture0"), 0);
+        GL41.glUniform1i(shader.getUniform("texture1"), 1);
+
+        GL41.glUniform4f(shader.getUniform("ufogColor"), instance.currentFogState.fogColor.x, instance.currentFogState.fogColor.y, instance.currentFogState.fogColor.z, instance.currentFogState.fogColor.w);
+        GL41.glUniform1i(shader.getUniform("ufogMode"), instance.currentFogState.fogMode.ordinal());
+        GL41.glUniform1f(shader.getUniform("ufogStart"), instance.currentFogState.fogStart);
+        GL41.glUniform1f(shader.getUniform("ufogEnd"), instance.currentFogState.fogEnd);
+        GL41.glUniform1f(shader.getUniform("ufogDensity"), instance.currentFogState.fogDensity);
+
+        GL41.glUniformMatrix4fv(shader.getUniform("normalTransform"), false, NORMAL_TRANSFORM_MATRIX.get(instance.mat4fBuf));
+        if (LIGHT_ENABLED) {
+            GL41.glUniform4f(shader.getUniform("lightModelAmbient"), LIGHT_MODEL_AMBIENT.x(), LIGHT_MODEL_AMBIENT.y(), LIGHT_MODEL_AMBIENT.z(), LIGHT_MODEL_AMBIENT.w());
+            LIGHT_0.position.get(lightBuf);
+            LIGHT_1.position.get(lightBuf.position(4));
+            GL41.glUniform4fv(shader.getUniform("lightSourcePosition"), lightBuf.position(8).flip());
+            LIGHT_0.diffuse.get(lightBuf);
+            LIGHT_1.diffuse.get(lightBuf.position(4));
+            GL41.glUniform4fv(shader.getUniform("lightSourceDiffuse"), lightBuf.position(8).flip());
+        } else {
+            GL41.glUniform4f(shader.getUniform("lightModelAmbient"), 1f, 1f, 1f, 1f);
+            LIGHT_0.position.get(lightBuf);
+            LIGHT_1.position.get(lightBuf.position(4));
+            GL41.glUniform4fv(shader.getUniform("lightSourcePosition"), lightBuf.position(8).flip());
+            lightBuf.put(0f).put(0f).put(0f).put(0f);
+            lightBuf.put(0f).put(0f).put(0f).put(0f);
+            GL41.glUniform4fv(shader.getUniform("lightSourceDiffuse"), lightBuf.position(8).flip());
+        }
+    }
+
+    public static void render(@NotNull RenderBuffer renderBuffer) {
+        render(renderBuffer.vao(), renderBuffer.vbo(), renderBuffer.offset(), renderBuffer.count(), renderBuffer.drawMode());
+    }
+
+    public static void render(int vao, int vbo, int offset, int count, @NotNull DrawMode drawMode) {
+        GL41.glBindVertexArray(vao);
+        GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+        instance.currentShader.bind();
+
+        globalSetUniforms(instance.currentShader);
+
+        GL41.glDrawArrays(drawMode.cap, offset, count);
+
+        GL41.glUseProgram(0);
+        GL41.glBindVertexArray(0);
+    }
+
+    public static void enableState(@NotNull State state) {
+        instance.currentStateConfig |= state.bitMask;
+        GL41.glEnable(state.cap);
+    }
+
+    public static void disableState(@NotNull State state) {
+        instance.currentStateConfig &= ~state.bitMask;
+        GL41.glDisable(state.cap);
+    }
+
+    public static boolean isStateEnabled(@NotNull State state) {
+        return state.isEnabled(instance.currentStateConfig);
+    }
+
+    public static @NotNull Matrix4f projectionM4f() {
+        return instance.projectionMatrixStack;
+    }
+
+    public static @NotNull Matrix4f viewM4f() {
+        return instance.viewMatrixStack;
+    }
+
+    public static @NotNull Matrix4f modelM4f() {
+        return instance.modelMatrixStack;
+    }
+
+    public static void setShader(@NotNull Shader shader) {
+        instance.currentShader = shader;
+    }
+
+    public static @NotNull Shader getShader() {
+        return instance.currentShader;
+    }
+
+    public static @NotNull FogManager.FogState getFogState() {
+        return instance.currentFogState;
+    }
+
+    public static void setDepthFunc(@NotNull CompareFunc func) {
+        instance.currentDepthFunc = func;
+        GL41.glDepthFunc(func.cap);
+    }
+
+    public static @NotNull CompareFunc getDepthFunc() {
+        return instance.currentDepthFunc;
+    }
+
+    public static void setCullFace(@NotNull CullFace cullFace) {
+        instance.currentCullFace = cullFace;
+        GL41.glCullFace(cullFace.cap);
+    }
+
+    public static void setBlendFunc(@NotNull BlendFactor srcFactor, @NotNull BlendFactor destFactor) {
+        instance.currentSFactor = srcFactor;
+        instance.currentDFactor = destFactor;
+        GL41.glBlendFunc(srcFactor.cap, destFactor.cap);
+    }
+
+    public static @NotNull BlendFactor getBlendSFactor() {
+        return instance.currentSFactor;
+    }
+
+    public static @NotNull BlendFactor getBlendDFactor() {
+        return instance.currentDFactor;
+    }
+
+    public static void setFrontFace(@NotNull FrontFace frontFace) {
+        instance.currentFrontFace = frontFace;
+        GL41.glFrontFace(frontFace.cap);
+    }
+
+    public static @NotNull FrontFace getFrontFace() {
+        return instance.currentFrontFace;
+    }
+
+    public static void setLineWidth(float lineWidth) {
+        instance.currentLineWidth = lineWidth;
+    }
+
+    public static float getLineWidth() {
+        return instance.currentLineWidth;
+    }
+
+    public static void setColorMask(boolean red, boolean green, boolean blue, boolean alpha) {
+        instance.currentColorMask = (byte) ((red ? 0b1000 : 0) | (green ? 0b0100 : 0) | (blue ? 0b0010 : 0) | (alpha ? 0b0001 : 0));
+        GL41.glColorMask(red, green, blue, alpha);
+    }
+
+    public static byte getColorMask() {
+        return instance.currentColorMask;
+    }
+
+    public static void setDepthMask(boolean flag) {
+        instance.currentDepthMask = flag;
+        GL41.glDepthMask(flag);
+    }
+
+    public static boolean getDepthMask() {
+        return instance.currentDepthMask;
+    }
+
+    public static void setPolygonOffset(float factor, float units) {
+        instance.currentPolygonFactor = factor;
+        instance.currentPolygonUnits = units;
+        GL41.glPolygonOffset(factor, units);
+    }
+
+    public static float getPolygonFactor() {
+        return instance.currentPolygonFactor;
+    }
+
+    public static float getPolygonUnits() {
+        return instance.currentPolygonUnits;
+    }
+
+    public static void setLightmapCoord1i(int lightmapCoord) {
+        setLightmapCoord2i(LightmapHelper.getBlockLightFromCoord(lightmapCoord), LightmapHelper.getSkyLightFromCoord(lightmapCoord));
+    }
+
+    public static void setLightmapCoord2i(int blockLight, int skyLight) {
+        setLightmapCoord2f((blockLight + 0.5f) / 16f, (skyLight + 0.5f) / 16f);
+    }
+
+    public static void setLightmapCoord2f(float blockLight, float skyLight) {
+        instance.currentLightmapBlock = blockLight;
+        instance.currentLightmapSky = skyLight;
+    }
+
+    public static float getLightmapBlock() {
+        return instance.currentLightmapBlock;
+    }
+
+    public static float getLightmapSky() {
+        return instance.currentLightmapSky;
+    }
+
+    public static void setColor1i(int argb) {
+        instance.currentColor = argb;
+    }
+
+    public static void setColor4f(float r, float g, float b, float a) {
+        setColor1i(Color.floatToIntARGB(a, r, g, b));
+    }
+
+    public static void setColor4d(double r, double g, double b, double a) {
+        setColor1i(Color.doubleToIntARGB(a, r, g, b));
+    }
+
+    public static void setColor4i(int r, int g, int b, int a) {
+        setColor1i(Color.intToIntARGB(a, r, g, b));
+    }
+
+    public static void setColor3f(float r, float g, float b) {
+        setColor4f(r, g, b, 1f);
+    }
+
+    public static void setColor(@NotNull Color color) {
+        setColor1i(color.value);
+    }
+
+    public static void setColor3fv(@NotNull Vector3fc colorVec) {
+        setColor4f(colorVec.x(), colorVec.y(), colorVec.z(), 1f);
+    }
+
+    public static void setColor4fv(@NotNull Vector4fc colorVec) {
+        setColor4f(colorVec.x(), colorVec.y(), colorVec.z(), colorVec.w());
+    }
+    public static void setColor3dv(@NotNull Vector3dc colorVec) {
+        setColor4d(colorVec.x(), colorVec.y(), colorVec.z(), 1d);
+    }
+
+    public static void setColor4dv(@NotNull Vector4dc colorVec) {
+        setColor4d(colorVec.x(), colorVec.y(), colorVec.z(), colorVec.w());
+    }
+
+    public static void setColor3d(double r, double g, double b) {
+        setColor4d(r, g, b, 1d);
+    }
+
+    public static void setColor3i(int r, int g, int b) {
+        setColor4i(r, g, b, 255);
+    }
+
+    public static int getColor() {
+        return instance.currentColor;
+    }
+
+    public static @NotNull TessellatorShader getTessellator() {
+        return instance.tessellatorShader;
+    }
+
+    public static void pushFrame() {
+        instance.stateConfigStack[instance.stackIndex] = instance.currentStateConfig;
+        instance.colorStack[instance.stackIndex] = instance.currentColor;
+        instance.shaderStack[instance.stackIndex] = instance.currentShader;
+        instance.fogStateStack[instance.stackIndex] =instance.currentFogState.copy();
+        instance.depthFuncStack[instance.stackIndex] = instance.currentDepthFunc;
+        instance.cullFaceStack[instance.stackIndex] = instance.currentCullFace;
+        instance.sFactorStack[instance.stackIndex] = instance.currentSFactor;
+        instance.dFactorStack[instance.stackIndex] = instance.currentDFactor;
+        instance.frontFaceStack[instance.stackIndex] = instance.currentFrontFace;
+        instance.lineWidthStack[instance.stackIndex] = instance.currentLineWidth;
+        instance.colorMaskStack[instance.stackIndex] = instance.currentColorMask;
+        instance.depthMaskStack[instance.stackIndex] = instance.currentDepthMask;
+        instance.polygonFactorStack[instance.stackIndex] = instance.currentPolygonFactor;
+        instance.polygonUnitsStack[instance.stackIndex] = instance.currentPolygonUnits;
+        instance.lightmapBlockStack[instance.stackIndex] = instance.currentLightmapBlock;
+        instance.lightmapSkyStack[instance.stackIndex] = instance.currentLightmapSky;
+
+        if (DEBUG) {
+            StackTraceElement[] eles = Thread.currentThread().getStackTrace();
+            instance.pushListenStack[instance.stackIndex] = eles[2];
+            if (instance.stackIndex >= RENDER_FRAMES_STACK_SIZE -1) {
+                for (int i = 0; i < RENDER_FRAMES_STACK_SIZE; i++) {
+                    StackTraceElement pushE = instance.pushListenStack[i];
+                    if (pushE != null) {
+                        LOGGER.error("Index: {} \t {}.{}({}.java:{})", i, pushE.getClassName(), pushE.getMethodName(), pushE.getClassName().substring(pushE.getClassName().lastIndexOf(".") + 1), pushE.getLineNumber());
+                    }
+                }
+                reset();
+                throw new RuntimeException("Stack Limit Exceeded");
+            }
+        }
+
+        instance.stackIndex++;
+
+        instance.projectionMatrixStack.pushMatrix();
+        instance.viewMatrixStack.pushMatrix();
+        instance.modelMatrixStack.pushMatrix();
+    }
+
+    public static void popFrame() {
+        instance.stackIndex--;
+        if (DEBUG) {
+            StackTraceElement[] eles = Thread.currentThread().getStackTrace();
+            if (instance.stackIndex < 0) {
+                for (int i = 0; i < RENDER_FRAMES_STACK_SIZE; i++) {
+                    StackTraceElement pushE = instance.pushListenStack[i];
+                    StackTraceElement popE = instance.popListenStack[i];
+                    LOGGER.error("Index: {} \t {}.{}({}.java:{})", i, pushE.getClassName(), pushE.getMethodName(), pushE.getClassName().substring(pushE.getClassName().lastIndexOf(".") + 1), pushE.getLineNumber());
+                    LOGGER.error("Index: {} \t {}.{}({}.java:{})", i, popE.getClassName(), popE.getMethodName(), popE.getClassName().substring(popE.getClassName().lastIndexOf(".") + 1), popE.getLineNumber());
+                }
+                reset();
+                throw new RuntimeException("Stack Limit Exceeded");
+            }
+            instance.popListenStack[instance.stackIndex ] = eles[2];
+        }
+
+        instance.projectionMatrixStack.popMatrix();
+        instance.viewMatrixStack.popMatrix();
+        instance.modelMatrixStack.popMatrix();
+
+        long newConfig = instance.stateConfigStack[instance.stackIndex];
+        State.setStateConfig(instance.currentStateConfig, newConfig);
+        instance.currentStateConfig = newConfig;
+
+        instance.currentColor = instance.colorStack[instance.stackIndex];
+        instance.currentShader = instance.shaderStack[instance.stackIndex];
+        instance.currentFogState = instance.fogStateStack[instance.stackIndex];
+
+        if (instance.currentDepthFunc != instance.depthFuncStack[instance.stackIndex]) {
+            instance.currentDepthFunc = instance.depthFuncStack[instance.stackIndex];
+            GL41.glDepthFunc(instance.currentDepthFunc.cap);
+        }
+
+        if (instance.currentCullFace != instance.cullFaceStack[instance.stackIndex]) {
+            instance.currentCullFace = instance.cullFaceStack[instance.stackIndex];
+            GL41.glCullFace(instance.currentCullFace.cap);
+        }
+
+        if (instance.currentSFactor != instance.sFactorStack[instance.stackIndex] || instance.currentDFactor != instance.dFactorStack[instance.stackIndex]) {
+            instance.currentSFactor = instance.sFactorStack[instance.stackIndex];
+            instance.currentDFactor = instance.dFactorStack[instance.stackIndex];
+            GL41.glBlendFunc(instance.currentSFactor.cap, instance.currentDFactor.cap);
+        }
+
+        if (instance.currentFrontFace != instance.frontFaceStack[instance.stackIndex]) {
+            instance.currentFrontFace = instance.frontFaceStack[instance.stackIndex];
+            GL41.glFrontFace(instance.currentFrontFace.cap);
+        }
+
+        instance.currentLineWidth = instance.lineWidthStack[instance.stackIndex];
+
+        if (instance.currentColorMask != instance.colorMaskStack[instance.stackIndex]) {
+            instance.currentColorMask = instance.colorMaskStack[instance.stackIndex];
+            GL41.glColorMask((instance.currentColorMask & 0b1000) != 0, (instance.currentColorMask & 0b0100) != 0, (instance.currentColorMask & 0b0010) != 0, (instance.currentColorMask & 0b0001) != 0);
+        }
+
+        if (instance.currentDepthMask != instance.depthMaskStack[instance.stackIndex]) {
+            instance.currentDepthMask = instance.depthMaskStack[instance.stackIndex];
+            GL41.glDepthMask(instance.currentDepthMask);
+        }
+
+        if (instance.currentPolygonFactor != instance.polygonFactorStack[instance.stackIndex] || instance.currentPolygonUnits != instance.polygonUnitsStack[instance.stackIndex]) {
+            instance.currentPolygonFactor = instance.polygonFactorStack[instance.stackIndex];
+            instance.currentPolygonUnits = instance.polygonUnitsStack[instance.stackIndex];
+            GL41.glPolygonOffset(instance.currentPolygonFactor, instance.currentPolygonUnits);
+        }
+
+        instance.currentLightmapBlock = instance.lightmapBlockStack[instance.stackIndex];
+        instance.currentLightmapSky = instance.lightmapSkyStack[instance.stackIndex];
+    }
+
+    protected static void reset() {
+        instance.stackIndex = 1;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
new file mode 100644
index 000000000..689a8feb2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -0,0 +1,57 @@
+package net.minecraft.client.render.renderer;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.shader.Shader;
+import net.minecraft.client.render.shader.ShaderGeometry;
+import net.minecraft.client.render.shader.ShaderProvider;
+import net.minecraft.client.render.shader.ShaderProviderInternal;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public final class Shaders {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public static final @NotNull List<@NotNull Shader> ALL_SHADERS = new ArrayList<>();
+    public static final @NotNull Map<@NotNull String, @NotNull Shader> SHADER_MAP = new HashMap<>();
+    public static final @NotNull ShaderProvider PROVIDER_INTERNAL = new ShaderProviderInternal("/shaders/");
+
+    public static final @NotNull Shader WORLD = register("world", new Shader());
+    public static final @NotNull Shader INTERFACE = register("interface", new Shader());
+    public static final @NotNull Shader COLOR = register("color", new Shader());
+    public static final @NotNull Shader COLOR_WORLD = register("color_world", new Shader());
+    public static final @NotNull Shader CLOUDS = register("clouds", new Shader());
+    public static final @NotNull ShaderGeometry PARTICLE = register("particle", new ShaderGeometry());
+    public static final @NotNull ShaderGeometry FONT = register("font", new ShaderGeometry());
+    public static final @NotNull ShaderGeometry LINES = register("lines", new ShaderGeometry());
+
+    public static @NotNull <T extends Shader> T register(@NotNull String id, @NotNull T shader) {
+        if (!ALL_SHADERS.contains(shader)) ALL_SHADERS.add(shader);
+        SHADER_MAP.put(id, shader);
+        return shader;
+    }
+
+    public static void init() {
+        for (Map.Entry<String, Shader> entry : SHADER_MAP.entrySet()) {
+            try {
+                entry.getValue().compile(PROVIDER_INTERNAL, entry.getKey());
+            } catch (Exception e) {
+                LOGGER.error("", e);
+            }
+        }
+    }
+
+    public static void reload() {
+        for (Map.Entry<String, Shader> entry : SHADER_MAP.entrySet()) {
+            try {
+                entry.getValue().delete();
+                entry.getValue().compile(PROVIDER_INTERNAL, entry.getKey());
+            } catch (Exception e) {
+                LOGGER.error("", e);
+            }
+        }
+    }
+}
